
export const constants = {

    gameName: "slgs",
    level: "level",

    icons: {
        coin_icon: "coin_icon",
    },

    // 玩家立绘初始缩放比
    playerBodyScale: 0.5,

    // 战斗播放攻击动画次数
    atkAniTotal: 1,
    // 角色每秒移动多少像素
    playerWalkSpeed: 500,
    // 怪物每秒移动多少像素
    monsterWalkSpeed: 600,

    // 战力增减时候，每隔多少秒变化一次战力
    atkChangeTimeGap: 0.03,
    // 战力增减时候，最大变化显示时间，单位：秒
    atkChangeTimeMax: 2,

    roleItemTypes: {
        player: -1,
        monster: 0,
        coinBox: 1,
        shop: 2,
        arrow: 3,
        atk: 4,
        equip: 5,
        skill: 6,
        dapao: 7,
        gunshi: 8,
    },

    arrowTypes: {
        right: 0,
        left: 1,
    },

    equipTypes: {
        weapon: 1,
        dress: 2,
    },

    shopTypes: {
        equip: 0,
        skill: 1,
        secret: 10
    },

    animations: {
        attack: "attack",
        chuansong: "chuansong",
        die: "die",
        hit: "hit",
        standBy: "standBy",
        walk: "walk",
        win: "win",

        animation: "animation",

        standBy1: "standBy1",
        standBy2: "standBy2",
        open1: "open1",
        open2: "open2",

    },

    // 倍增类型
    atkChangeTypes: {
        // 加法
        add: 0,
        // 乘法
        multi: 1,
    },

    turnTableAwardTypes: {
        coin: 1,
        skill: 2,
        skin: 3,
    },

    audioNames: {
        bgm: "bgm",
        button: "button",
        baoxiang: "baoxiang",
        gold: "gold",
        hit_gong: "hit_gong",
        figure: "figure",
        win: "win",
        lose: "lose",
        equip: "equip",
        gunshi: "gunshi",
        pao: "pao",
    },

    roleIds: {
        gong_jian_shou: 1,
        jian_shi: 2,
    },

    monsterIds: {
        lang: 1,
        xie_zi: 2,
        xi_niu: 3,
        ye_zhu: 4,
        tu_jiu: 5,
        ju_ren: 6,
    },

    tableName: {
        equip: "equip",
        role: "role",
        shop_equip: "shop_equip",
        shop_secret: "shop_secret",
        shop_skill: "shop_skill",
        skill: "skill",
        turn_table: "turn_table",
        monster: "monster",
    },

    bundles: {
        common: {
            name: "common",
            dir: {
                audio: "audio",
                icon: "icon",
                layer: "prefab/layer",
                level: "prefab/level",
            },
            roleBox: "prefab/role/role_box",
            spine: {
                roleDir: "spine/role",
                skillDir: "spine/skill",
                shouzhi: "spine/effect/shouzhi/shouzhi",
            }
        },
        design: {
            name: "design",
            dir: {
                common: "common",
            }
        },
        audio: {
            name: "audio",
        }
    },

    layers: {
        LoadingLayer: {
            name: "LoadingLayer",
        },
        NoticeLayer: {
            name: "NoticeLayer",
        },
        StartLayer: {
            name: "StartLayer",
            bundle: "common",
            path: "prefab/layer/StartLayer"
        },
        LevelLayer: {
            name: "LevelLayer",
            bundle: "common",
            path: "prefab/layer/LevelLayer"
        },
        FightFailLayer: {
            name: "FightFailLayer",
            bundle: "common",
            path: "prefab/layer/FightFailLayer"
        },
        LevelSuccessLayer: {
            name: "LevelSuccessLayer",
            bundle: "common",
            path: "prefab/layer/LevelSuccessLayer"
        },
        LevelEspSelectLayer: {
            name: "LevelEspSelectLayer",
            bundle: "common",
            path: "prefab/layer/LevelEspSelectLayer"
        },
        ShopLayer: {
            name: "ShopLayer",
            bundle: "common",
            path: "prefab/layer/ShopLayer"
        },
        TurnTableLayer: {
            name: "TurnTableLayer",
            bundle: "common",
            path: "prefab/layer/TurnTableLayer"
        },
        SkinLayer: {
            name: "SkinLayer",
            bundle: "common",
            path: "prefab/layer/SkinLayer"
        },
        AwardGetLayer: {
            name: "AwardGetLayer",
            bundle: "common",
            path: "prefab/layer/AwardGetLayer"
        },
        CoinGetEffectLayer: {
            name: "CoinGetEffectLayer",
            bundle: "common",
            path: "prefab/layer/CoinGetEffectLayer"
        },
        AdCoinLayer: {
            name: "AdCoinLayer",
            bundle: "common",
            path: "prefab/layer/AdCoinLayer"
        },
        GameContinueLayer: {
            name: "GameContinueLayer",
            bundle: "common",
            path: "prefab/layer/GameContinueLayer"
        },
    },

}

